<?php

/**
 * $Id: KTLDAPAuthenticationPlugin.php 5316 2006-04-22 13:14:00Z bshuttle $
 *
 * Copyright (c) 2006 Jam Warehouse http://www.jamwarehouse.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; using version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 *
 * You can contact the copyright owner regarding licensing via the contact
 * details that can be found on the KnowledgeTree web site:
 *
 *         http://www.ktdms.com/
 */

require_once(KT_LIB_DIR . '/plugins/plugin.inc.php');
require_once(KT_LIB_DIR . '/plugins/pluginregistry.inc.php');

class KTLDAPAuthenticationPlugin extends KTPlugin {
    var $sNamespace = "ktstandard.ldapauthentication.plugin";
    var $autoRegister = true;
    
    function KTLDAPAuthenticationPlugin($sFilename = null) {
        $res = parent::KTPlugin($sFilename);
        $this->sFriendlyName = _kt('LDAP Authentication Plugin');
        return $res;
    }            

    function setup() {
        $this->registerAuthenticationProvider(_kt('LDAP Authentication'),
            'KTLDAPAuthenticationProvider', 'ktstandard.authentication.ldapprovider',
            'ldap/ldapauthenticationprovider.inc.php');
        $this->registerAuthenticationProvider(_kt('ActiveDirectory Authentication'),
            'KTActiveDirectoryAuthenticationProvider', 'ktstandard.authentication.adprovider',
            'ldap/activedirectoryauthenticationprovider.inc.php');
    }
}

$oPluginRegistry =& KTPluginRegistry::getSingleton();
$oPluginRegistry->registerPlugin('KTLDAPAuthenticationPlugin', 'ktstandard.ldapauthentication.plugin', __FILE__);
